<?php
/**
*
* @copyright (c) 2011 Laf Innovative, Ltd.
* @license http://www.opensource.org/licenses/mit-license.php MIT License
* 
*/

require_once("./admin/database.php");
require_once("./admin/functions.php");
require('./admin/smarty/Smarty.class.php');
$smarty = new Smarty();
$smarty->template_dir = './admin/templates';
$smarty->compile_dir = './admin/smarty/templates_c';
$smarty->cache_dir = './admin/smarty/cache';
$smarty->config_dir = './admin/smarty/configs';
$startTime = array_sum(explode(" ",microtime()));
$smarty->assign('dir_title', cfg("title"));
$smarty->assign('dir_url', cfg("url"));

if(!isset($_REQUEST['page'])){ $page = 1; } else{ $page = $_REQUEST['page']; }
$limit = cfg("num_pages");
$result_start = $page-1 == 0 ? 0 : (($page-1)*$limit);
$smarty->assign('result_start', $result_start);
$smarty->register_prefilter('a');
if(isset($_REQUEST['swords']) || isset($_REQUEST['q'])){
	if(isset($_GET['q'])){
		$_REQUEST['swords'] = $_REQUEST['q'];
	}
	$swords = stripslashes($_REQUEST['swords']);
	$searchwords = addslashes(htmlspecialchars($_REQUEST['swords']));

$type = "";
if(isset($_REQUEST['type']) == "links"){
	$type = "&type=links";
	$result = mysql_query('SELECT `id`, MATCH(`url`,`title`,`description`) AGAINST ("' . mysql_real_escape_string($searchwords) . '") as Relevance FROM `links` WHERE MATCH (`url`,`title`,`description`) AGAINST("' . mysql_real_escape_string($searchwords) . '" IN BOOLEAN MODE)');
	echo mysql_error();
	$NumberOfResults = mysql_num_rows($result);
	$NumberOfPages=ceil($NumberOfResults/$limit); 

	$result = mysql_query('SELECT *, MATCH(`url`,`title`,`description`) AGAINST ("' . mysql_real_escape_string($searchwords) . '") as Relevance FROM `links` WHERE MATCH (`url`,`title`,`description`) AGAINST("' . mysql_real_escape_string($searchwords) . '" IN BOOLEAN MODE) ORDER BY `Relevance` DESC, `gpr` DESC LIMIT ' . mysql_real_escape_string(($page-1)*$limit) . ',' . mysql_real_escape_string($limit) . '');
	echo mysql_error();
	if(mysql_num_rows($result)){
		while($row = mysql_fetch_array($result)){
			$row['Relevance'] = round($row['Relevance'],3);
			$row['title'] = stripslashes(substr($row['title'],0,cfg("chars_title"))."...");
			$row['title'] = highlight($row['title'],$swords);
			$row['description'] = stripslashes(substr($row['description'],0,cfg("chars_desc"))."...");
			$row['description'] = highlight($row['description'],$swords);
			$results[] = $row;
			}
		$smarty->assign('swords',$swords);
		$smarty->assign('results', $results);
		}
	}
else{
	$result = mysql_query('SELECT `id`, MATCH(`url`,`title`,`description`) AGAINST ("' . mysql_real_escape_string($searchwords) . '") as Relevance FROM `pages` WHERE MATCH (`url`,`title`,`description`) AGAINST("' . mysql_real_escape_string($searchwords) . '" IN BOOLEAN MODE)');
	echo mysql_error();
	$NumberOfResults = mysql_num_rows($result);
	$NumberOfPages=ceil($NumberOfResults/$limit); 

	$result = mysql_query('SELECT *, MATCH(`url`,`title`,`description`) AGAINST ("' . mysql_real_escape_string($searchwords) . '") as Relevance FROM `pages` WHERE MATCH (`url`,`title`,`description`) AGAINST("'.$searchwords.'" IN BOOLEAN MODE) ORDER BY `Relevance` DESC, `gpr` DESC LIMIT ' . mysql_real_escape_string(($page-1)*$limit) . ',' . mysql_real_escape_string($limit) . '');
	echo mysql_error();
	if(mysql_num_rows($result)){
		while($row = mysql_fetch_array($result)){
			$row['Relevance'] = round($row['Relevance'],3);
			$row['title'] = stripslashes(substr($row['title'],0,cfg("chars_title"))."...");
			$row['title'] = highlight($row['title'],$swords);
			$row['description'] = stripslashes(substr($row['description'],0,cfg("chars_desc"))."...");
			$row['description'] = highlight($row['description'],$swords);
			$results[] = $row;
			}
		$smarty->assign('swords',$swords);
		$smarty->assign('results', $results);
		}
	}



	$Nav = "";
	$Nav_l = "";
	if($page > 1) { 
		$Nav .= "<a href=\"?page=".($page-1).$type."&q=".urlencode($swords)."\" class=\"bold\">&laquo; Previous</a>"; 
		}
	for($i = 1 ; $i <= $NumberOfPages ; $i++){
		if($page > 5){ $Nav_l = $page - 5; }
		$Nav_h = $page + 5;
		if($i == $page){
			$Nav .= " <B>$i</B> ";
			}
		elseif(($i > $Nav_l) && ($i < $Nav_h)){
			$Nav .= " <a href=\"?page=".$i.$type."&q=".urlencode($swords)."\">$i</a> ";
			}
		}
	if($page < $NumberOfPages){
		$Nav .= "<a href=\"?page=".($page+1).$type."&q=".urlencode($swords)."\" class=\"bold\">Next &raquo;</a>";
		}
	$smarty->assign('nav', $Nav);
	$smarty->assign('pages_num', $NumberOfPages);
	$smarty->assign('results_num', $NumberOfResults);
	$smarty->assign('results_limit', $limit);
	$smarty->assign('meta_title', cfg("title")." : ".$swords);

	if((cfg("search_log") == "1") && ($page == 1) && ($searchwords != "")){ mysql_query("INSERT INTO `search_log` (date, matches, text) VALUES ('" . mysql_real_escape_string(date("Y-m-d")) . "', '" . mysql_real_escape_string($NumberOfResults) . "', '" . mysql_real_escape_string($searchwords) . "')"); }

	}
else{ $smarty->assign('advanced',"1"); }

function highlight( $str, $var ){
	$var = str_replace('+','',$var);
	$var = str_replace('~','',$var);
	$var = str_replace('(','',$var);
	$var = str_replace(')','',$var);
	$var = str_replace('>','',$var);
	$var = str_replace('<','',$var);
	$var = str_replace('"','',$var);
	$var = array_diff ( array_map ( 'trim', explode ( ' ', trim ( $var ) ) ), array ( '' ) );
	return preg_replace ( "/\b(" . implode ( ' ', $var ) . "|" . implode ( '|', $var ) . ")\b/i", "<b>\\1</b>", $str );
	}
$smarty->assign('exetime',round((array_sum(explode(" ",microtime())) - $startTime),4));
$smarty->display('search.html');

?>